# NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
# https://openapi-generator.tech
# Do not edit the class manually.

defmodule FoyerAPI.Model.Member do
  @moduledoc """
  
  """

  @derive [Poison.Encoder]
  defstruct [
    :id,
    :MemberMlsAccessYN,
    :MemberAORkeyNumeric,
    :MemberKeyNumeric,
    :OfficeKeyNumeric,
    :JobTitle,
    :MemberAORMlsId,
    :MemberAORkey,
    :MemberAddress1,
    :MemberAddress2,
    :MemberAssociationComments,
    :MemberCarrierRoute,
    :MemberCity,
    :MemberDirectPhone,
    :MemberEmail,
    :MemberFax,
    :MemberFirstName,
    :MemberFullName,
    :MemberHomePhone,
    :MemberIsAssistantTo,
    :MemberKey,
    :MemberLastName,
    :MemberLoginId,
    :MemberMiddleName,
    :MemberMlsId,
    :MemberMobilePhone,
    :MemberNamePrefix,
    :MemberNameSuffix,
    :MemberNationalAssociationId,
    :MemberNickname,
    :MemberOfficePhone,
    :MemberOfficePhoneExt,
    :MemberPager,
    :MemberPassword,
    :MemberPhoneTTYTDD,
    :MemberPostalCode,
    :MemberPostalCodePlus4,
    :MemberPreferredPhone,
    :MemberPreferredPhoneExt,
    :MemberStateLicense,
    :MemberTollFreePhone,
    :MemberVoiceMail,
    :MemberVoiceMailExt,
    :OfficeKey,
    :OfficeMlsId,
    :OfficeName,
    :OriginatingSystemID,
    :OriginatingSystemMemberKey,
    :OriginatingSystemName,
    :SourceSystemID,
    :SourceSystemMemberKey,
    :SourceSystemName,
    :MemberDesignation,
    :MemberLanguages,
    :SyndicateTo,
    :MemberAOR,
    :MemberCountry,
    :MemberCountyOrParish,
    :MemberMlsSecurityClass,
    :MemberOtherPhoneType,
    :MemberStateLicenseState,
    :MemberStateOrProvince,
    :MemberStatus,
    :MemberType,
    :SocialMediaType,
    :LastLoginTimestamp,
    :ModificationTimestamp,
    :OriginalEntryTimestamp,
    :Office,
    :OriginatingSystem,
    :SourceSystem,
    :Contacts,
    :HistoryTransactionals,
    :OUIDs,
    :BrokerOffices,
    :ManagerOffices,
    :OpenHouses,
    :BuyerAgentProperties,
    :CoBuyerAgentProperties,
    :CoListAgentProperties,
    :ListAgentProperties,
    :Prospectings,
    :SavedSearches,
    :Showings,
    :TeamMembers,
    :Teams
  ]

  @type t :: %__MODULE__{
    :id => integer() | nil,
    :MemberMlsAccessYN => boolean() | nil,
    :MemberAORkeyNumeric => float() | nil,
    :MemberKeyNumeric => float() | nil,
    :OfficeKeyNumeric => float() | nil,
    :JobTitle => String.t | nil,
    :MemberAORMlsId => String.t | nil,
    :MemberAORkey => String.t | nil,
    :MemberAddress1 => String.t | nil,
    :MemberAddress2 => String.t | nil,
    :MemberAssociationComments => String.t | nil,
    :MemberCarrierRoute => String.t | nil,
    :MemberCity => String.t | nil,
    :MemberDirectPhone => String.t | nil,
    :MemberEmail => String.t | nil,
    :MemberFax => String.t | nil,
    :MemberFirstName => String.t | nil,
    :MemberFullName => String.t | nil,
    :MemberHomePhone => String.t | nil,
    :MemberIsAssistantTo => String.t | nil,
    :MemberKey => String.t | nil,
    :MemberLastName => String.t | nil,
    :MemberLoginId => String.t | nil,
    :MemberMiddleName => String.t | nil,
    :MemberMlsId => String.t | nil,
    :MemberMobilePhone => String.t | nil,
    :MemberNamePrefix => String.t | nil,
    :MemberNameSuffix => String.t | nil,
    :MemberNationalAssociationId => String.t | nil,
    :MemberNickname => String.t | nil,
    :MemberOfficePhone => String.t | nil,
    :MemberOfficePhoneExt => String.t | nil,
    :MemberPager => String.t | nil,
    :MemberPassword => String.t | nil,
    :MemberPhoneTTYTDD => String.t | nil,
    :MemberPostalCode => String.t | nil,
    :MemberPostalCodePlus4 => String.t | nil,
    :MemberPreferredPhone => String.t | nil,
    :MemberPreferredPhoneExt => String.t | nil,
    :MemberStateLicense => String.t | nil,
    :MemberTollFreePhone => String.t | nil,
    :MemberVoiceMail => String.t | nil,
    :MemberVoiceMailExt => String.t | nil,
    :OfficeKey => String.t | nil,
    :OfficeMlsId => String.t | nil,
    :OfficeName => String.t | nil,
    :OriginatingSystemID => String.t | nil,
    :OriginatingSystemMemberKey => String.t | nil,
    :OriginatingSystemName => String.t | nil,
    :SourceSystemID => String.t | nil,
    :SourceSystemMemberKey => String.t | nil,
    :SourceSystemName => String.t | nil,
    :MemberDesignation => [String.t] | nil,
    :MemberLanguages => [String.t] | nil,
    :SyndicateTo => [String.t] | nil,
    :MemberAOR => String.t | nil,
    :MemberCountry => String.t | nil,
    :MemberCountyOrParish => String.t | nil,
    :MemberMlsSecurityClass => String.t | nil,
    :MemberOtherPhoneType => String.t | nil,
    :MemberStateLicenseState => String.t | nil,
    :MemberStateOrProvince => String.t | nil,
    :MemberStatus => String.t | nil,
    :MemberType => String.t | nil,
    :SocialMediaType => String.t | nil,
    :LastLoginTimestamp => Date.t | nil,
    :ModificationTimestamp => Date.t | nil,
    :OriginalEntryTimestamp => Date.t | nil,
    :Office => FoyerAPI.Model.Office.t | nil,
    :OriginatingSystem => FoyerAPI.Model.Ouid.t | nil,
    :SourceSystem => FoyerAPI.Model.Ouid.t | nil,
    :Contacts => [FoyerAPI.Model.Contacts.t] | nil,
    :HistoryTransactionals => [FoyerAPI.Model.HistoryTransactional.t] | nil,
    :OUIDs => [FoyerAPI.Model.Ouid.t] | nil,
    :BrokerOffices => [FoyerAPI.Model.Office.t] | nil,
    :ManagerOffices => [FoyerAPI.Model.Office.t] | nil,
    :OpenHouses => [FoyerAPI.Model.OpenHouse.t] | nil,
    :BuyerAgentProperties => [FoyerAPI.Model.Property.t] | nil,
    :CoBuyerAgentProperties => [FoyerAPI.Model.Property.t] | nil,
    :CoListAgentProperties => [FoyerAPI.Model.Property.t] | nil,
    :ListAgentProperties => [FoyerAPI.Model.Property.t] | nil,
    :Prospectings => [FoyerAPI.Model.Prospecting.t] | nil,
    :SavedSearches => [FoyerAPI.Model.SavedSearch.t] | nil,
    :Showings => [FoyerAPI.Model.Showing.t] | nil,
    :TeamMembers => [FoyerAPI.Model.TeamMembers.t] | nil,
    :Teams => [FoyerAPI.Model.Teams.t] | nil
  }
end

defimpl Poison.Decoder, for: FoyerAPI.Model.Member do
  import FoyerAPI.Deserializer
  def decode(value, options) do
    value
    |> deserialize(:LastLoginTimestamp, :date, nil, options)
    |> deserialize(:ModificationTimestamp, :date, nil, options)
    |> deserialize(:OriginalEntryTimestamp, :date, nil, options)
    |> deserialize(:Office, :struct, FoyerAPI.Model.Office, options)
    |> deserialize(:OriginatingSystem, :struct, FoyerAPI.Model.Ouid, options)
    |> deserialize(:SourceSystem, :struct, FoyerAPI.Model.Ouid, options)
    |> deserialize(:Contacts, :list, FoyerAPI.Model.Contacts, options)
    |> deserialize(:HistoryTransactionals, :list, FoyerAPI.Model.HistoryTransactional, options)
    |> deserialize(:OUIDs, :list, FoyerAPI.Model.Ouid, options)
    |> deserialize(:BrokerOffices, :list, FoyerAPI.Model.Office, options)
    |> deserialize(:ManagerOffices, :list, FoyerAPI.Model.Office, options)
    |> deserialize(:OpenHouses, :list, FoyerAPI.Model.OpenHouse, options)
    |> deserialize(:BuyerAgentProperties, :list, FoyerAPI.Model.Property, options)
    |> deserialize(:CoBuyerAgentProperties, :list, FoyerAPI.Model.Property, options)
    |> deserialize(:CoListAgentProperties, :list, FoyerAPI.Model.Property, options)
    |> deserialize(:ListAgentProperties, :list, FoyerAPI.Model.Property, options)
    |> deserialize(:Prospectings, :list, FoyerAPI.Model.Prospecting, options)
    |> deserialize(:SavedSearches, :list, FoyerAPI.Model.SavedSearch, options)
    |> deserialize(:Showings, :list, FoyerAPI.Model.Showing, options)
    |> deserialize(:TeamMembers, :list, FoyerAPI.Model.TeamMembers, options)
    |> deserialize(:Teams, :list, FoyerAPI.Model.Teams, options)
  end
end

